=== modified file 'lib/lp/soyuz/model/packagecloner.py'
--- lib/lp/soyuz/model/packagecloner.py	2011-11-29 05:15:07 +0000
+++ lib/lp/soyuz/model/packagecloner.py	2011-12-02 07:24:12 +0000
@@ -235,13 +235,15 @@
         store.execute("""
             INSERT INTO SourcePackagePublishingHistory (
                 sourcepackagerelease, distroseries, status, component,
-                section, archive, datecreated, datepublished, pocket)
+                section, archive, datecreated, datepublished, pocket,
+                sourcepackagename)
             SELECT
                 mcd.s_sourcepackagerelease AS sourcepackagerelease,
                 %s AS distroseries, mcd.s_status AS status,
                 mcd.s_component AS component, mcd.s_section AS section,
                 %s AS archive, %s AS datecreated, %s AS datepublished,
-                %s AS pocket
+                %s AS pocket,
+                sourcepackagename_id
             FROM tmp_merge_copy_data mcd
             WHERE mcd.obsoleted = True OR mcd.missing = True
             """ % sqlvalues(
@@ -294,8 +296,9 @@
                 s_component = secsrc.component,
                 s_section = secsrc.section
             FROM
-                sourcepackagepublishinghistory secsrc,
-                sourcepackagerelease spr, sourcepackagename spn
+                SourcePackagePublishingHistory secsrc,
+                SourcePackageRelease spr,
+                SourcePackageName spn
             WHERE
                 secsrc.archive = %s AND secsrc.status IN (%s, %s) AND
                 secsrc.distroseries = %s AND secsrc.pocket = %s AND
@@ -318,22 +321,29 @@
         # the target archive.
         find_origin_only_packages = """
             INSERT INTO tmp_merge_copy_data (
-                s_sspph, s_sourcepackagerelease, sourcepackagename, s_version,
-                missing, s_status, s_component, s_section)
+                s_sspph, s_sourcepackagerelease, sourcepackagename,
+                sourcepackagename_id, s_version, missing, s_status,
+                s_component, s_section)
             SELECT
                 secsrc.id AS s_sspph,
                 secsrc.sourcepackagerelease AS s_sourcepackagerelease,
-                spn.name AS sourcepackagename, spr.version AS s_version,
-                True AS missing, secsrc.status AS s_status,
-                secsrc.component AS s_component, secsrc.section AS s_section
-            FROM
-                sourcepackagepublishinghistory secsrc,
-                sourcepackagerelease spr, sourcepackagename spn
+                spn.name AS sourcepackagename,
+                spn.id AS sourcepackagename_id,
+                spr.version AS s_version,
+                True AS missing,
+                secsrc.status AS s_status,
+                secsrc.component AS s_component,
+                secsrc.section AS s_section
+            FROM SourcePackagePublishingHistory secsrc
+            JOIN SourcePackageRelease AS spr ON
+                spr.id = secsrc.sourcepackagerelease
+            JOIN SourcePackageName AS spn ON
+                spn.id = spr.sourcepackagename
             WHERE
-                secsrc.archive = %s AND secsrc.status IN (%s, %s) AND
-                secsrc.distroseries = %s AND secsrc.pocket = %s AND
-                secsrc.sourcepackagerelease = spr.id AND
-                spr.sourcepackagename = spn.id AND
+                secsrc.archive = %s AND
+                secsrc.status IN (%s, %s) AND
+                secsrc.distroseries = %s AND
+                secsrc.pocket = %s AND
                 spn.name NOT IN (
                     SELECT sourcepackagename FROM tmp_merge_copy_data)
         """ % sqlvalues(
@@ -383,7 +393,8 @@
                 -- recent source package.
                 obsoleted boolean DEFAULT false NOT NULL,
                 missing boolean DEFAULT false NOT NULL,
-                sourcepackagename text NOT NULL
+                sourcepackagename text NOT NULL,
+                sourcepackagename_id integer NOT NULL
             );
             CREATE INDEX source_name_index
             ON tmp_merge_copy_data USING btree (sourcepackagename);
@@ -392,19 +403,24 @@
         # archive considering the distroseries, pocket and component.
         pop_query = """
             INSERT INTO tmp_merge_copy_data (
-                t_sspph, t_sourcepackagerelease, sourcepackagename, t_version)
+                t_sspph, t_sourcepackagerelease, sourcepackagename,
+                sourcepackagename_id, t_version)
             SELECT
                 secsrc.id AS t_sspph,
                 secsrc.sourcepackagerelease AS t_sourcepackagerelease,
-                spn.name AS sourcepackagerelease, spr.version AS t_version
-            FROM
-                sourcepackagepublishinghistory secsrc,
-                sourcepackagerelease spr, sourcepackagename spn
+                spn.name AS sourcepackagerelease,
+                spn.id AS sourcepackagename_id,
+                spr.version AS t_version
+            FROM SourcePackagePublishingHistory secsrc
+            JOIN SourcePackageRelease AS spr ON
+                spr.id = secsrc.sourcepackagerelease
+            JOIN SourcePackageName AS spn ON
+                spn.id = spr.sourcepackagename
             WHERE
-                secsrc.archive = %s AND secsrc.status IN (%s, %s) AND
-                secsrc.distroseries = %s AND secsrc.pocket = %s AND
-                secsrc.sourcepackagerelease = spr.id AND
-                spr.sourcepackagename = spn.id
+                secsrc.archive = %s AND
+                secsrc.status IN (%s, %s) AND
+                secsrc.distroseries = %s AND
+                secsrc.pocket = %s
         """ % sqlvalues(
                 destination.archive,
                 PackagePublishingStatus.PENDING,
@@ -464,23 +480,22 @@
             query += '''
                 AND spph.sourcepackagerelease IN (
                     SELECT spr.id
-                    FROM SourcePackageRelease AS spr, SourcePackageName AS spn
-                    WHERE
-                        spr.sourcepackagename = spn.id AND spn.name IN %s
+                    FROM SourcePackageRelease AS spr
+                    JOIN SourcePackageName AS spn ON
+                        spn.id = spr.sourcepackagename
+                    WHERE spn.name IN %s
                 )''' % sqlvalues(sourcepackagenames)
 
         if origin.packagesets:
             query += '''
                 AND spph.sourcepackagerelease IN (
                     SELECT spr.id
-                    FROM
-                        SourcePackageRelease AS spr,
-                        packagesetsources AS pss,
-                        flatpackagesetinclusion AS fpsi
-                    WHERE
-                        spr.sourcepackagename = pss.sourcepackagename AND
-                        pss.packageset = fpsi.child AND
-                        fpsi.parent in %s
+                    FROM SourcePackageRelease AS spr
+                    JOIN PackagesetSources AS pss ON
+                        PSS.sourcepackagename = spr.sourcepackagename
+                    JOIN FlatPackagesetInclusion AS fpsi ON
+                        fpsi.child = pss.packageset
+                    WHERE fpsi.parent in %s
                 )
                      ''' % sqlvalues([p.id for p in origin.packagesets])
 
@@ -526,14 +541,16 @@
         """
         fresher_info = sorted(store.execute("""
             SELECT sourcepackagename, s_version, t_version
-            FROM tmp_merge_copy_data WHERE obsoleted = True;
+            FROM tmp_merge_copy_data
+            WHERE obsoleted = True;
         """))
         logger.info('Fresher packages: %d' % len(fresher_info))
         for info in fresher_info:
             logger.info('* %s (%s > %s)' % info)
         new_info = sorted(store.execute("""
             SELECT sourcepackagename, s_version
-            FROM tmp_merge_copy_data WHERE missing = True;
+            FROM tmp_merge_copy_data
+            WHERE missing = True;
         """))
         logger.info('New packages: %d' % len(new_info))
         for info in new_info:

=== modified file 'lib/lp/soyuz/tests/test_packagecloner.py'
--- lib/lp/soyuz/tests/test_packagecloner.py	2011-07-21 19:32:05 +0000
+++ lib/lp/soyuz/tests/test_packagecloner.py	2011-12-05 10:22:53 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 __metaclass__ = type
@@ -19,6 +19,7 @@
 from lp.soyuz.interfaces.component import IComponentSet
 from lp.soyuz.interfaces.packagecloner import IPackageCloner
 from lp.soyuz.interfaces.publishing import (
+    active_publishing_status,
     IPublishingSet,
     )
 from lp.soyuz.model.processor import ProcessorFamilySet
@@ -49,8 +50,7 @@
         expected_set = set([(info.name, info.version) for info in expected])
         sources = archive.getPublishedSources(
             distroseries=distroseries,
-            status=(PackagePublishingStatus.PENDING,
-                PackagePublishingStatus.PUBLISHED))
+            status=active_publishing_status)
         actual_set = set()
         for source in sources:
             source = removeSecurityProxy(source)
@@ -94,8 +94,7 @@
         archive = distroseries.distribution.main_archive
         sources = archive.getPublishedSources(
             distroseries=distroseries,
-            status=(PackagePublishingStatus.PENDING,
-                PackagePublishingStatus.PUBLISHED),
+            status=active_publishing_status,
             name=info.name, exact_match=True)
         for src in sources:
             src.supersede()
@@ -516,6 +515,17 @@
         cloner = getUtility(IPackageCloner)
         return cloner.mergeCopy(source_location, target_location)
 
+    def test_mergeCopy_initializes_sourcepackagename(self):
+        copy_archive, distroseries = self.makeCopyArchive([])
+        package_info = PackageInfo(
+            "bzr", "2.1", status=PackagePublishingStatus.PUBLISHED)
+        self.createSourcePublications([package_info], distroseries)
+        self.mergeCopy(copy_archive, distroseries)
+        [spph] = copy_archive.getPublishedSources()
+        self.assertEqual(
+            spph.sourcepackagerelease.sourcepackagename,
+            spph.sourcepackagename)
+
     def testMergeCopyNoChanges(self):
         package_info = PackageInfo(
             "bzr", "2.1", status=PackagePublishingStatus.PUBLISHED)

